



class DZMEvent{
    constructor(id) {

        this.event = new Event('dzmEvent')
        this.event.eventId = id

    }
}

class DZMEventDispatcher{
    constructor(id,eventId, trigger) {
        this.eventDispatcherElement = null
        this.eventListeners = []
        this.id = id
        this.eventId = eventId
        this.trigger = trigger
        this.event = new DZMEvent(eventId)
        this.selectors = {
            eventDispatcherSelector: `[data-dzm-event-dispatcher-id="${id}"]`,
            eventListenersSelector: `[data-dzm-event-listener-id="${eventId}"]`
        }


    }

    init(){
        console.log('init EventDispatcher', this.id, this.trigger)
        this.eventDispatcherElement = document.querySelector(this.selectors.eventDispatcherSelector)
        console.log('EVENTDISPATCHER::',this.eventDispatcherElement)
        this.eventListeners = document.querySelectorAll(this.selectors.eventListenersSelector)
        console.log('LISTENERS::',this.eventListeners)
        if(this.eventListeners.length <= 0)
            console.warn('No listeners')

        if(this.eventDispatcherElement != null){
            this.eventDispatcherElement.addEventListener(this.trigger,()=>{
                Array.from(this.eventListeners).forEach(listener=>{
                    listener.dispatchEvent(this.event.event)
                    console.log('fire', this.event.event)

                })
            })
        }
    }
}

class DZMEventListener{
    constructor(id, callback) {
        this.eventListener = null
        this.id = id;
        this.selectors = {
            eventListenerSelector:`[data-dzm-event-listener-id="${id}"]`
        }
        this.callback = callback
    }

    init(){
        this.eventListener = document.querySelector(this.selectors.eventListenerSelector)
        if(this.eventListener != null){
            this.eventListener.addEventListener('dzmEvent',(e)=>{
                if(e.eventId === this.id){
                    this.callback()
                }
            })
        }
    }
}

class DZMTest{
    constructor(a,b) {
        this.a = a
        this.b = b
    }
    init(){
        console.log('init',this.a,this.b)
    }
}
