class CookieTrigger{
    constructor() {
        this.btns = []
        this.consentBtn = null
        this.selectors = {
            btnSelector:'[data-dzm-cookie-trigger]',
            consentSelector:'#consent-settings-btn',
        }


    }

    init(){
        this.btns = document.querySelectorAll(this.selectors.btnSelector)
        this.consentBtn = document.querySelector(this.selectors.consentSelector)
        this.btns.forEach(btn=>{
            btn.addEventListener('click', ()=>{
                this.triggerConsent()
            })
        })
    }

    triggerConsent(){
        this.consentBtn.click()
    }
}

window.onload = () => {
    let cookieTrigger = new CookieTrigger()
    cookieTrigger.init()
}
